︠fff9b57e-e36d-4263-9514-a30f622bddd2s︠
reset
var('x')
︡833b1041-5f38-4efd-b7cc-9fb4a167d6b0︡{"stdout":"<function reset at 0x7f25649c4050>"}︡{"stdout":"\n"}︡{"stdout":"x\n"}︡{"done":true}
︠345f69b1-5f3f-4386-bd61-d1fdbafdad39︠
#Exercise 1. Make a CAS function fcn_and_tangent(fcn,x0,a,b,c) that takes a differentiable function f, a point x0  in the function domain, end points of an interval that contains the point, and a small float c and returns
# (a) a figure with the function graph on [a,b] and the tangent line passing through the point (x0, f(x0)).
# (b) the relative error of the approximation of f(x0+c) by the linearization at the point x0.
︡1a22dfa1-2651-442e-94a2-4964b487a463︡
︠ef28b687-2b02-4edf-8d13-60cbecbbb614s︠
def fcn_and_tangent(fcn,x0,a,b,c):
    fcn_plot=plot(fcn,a,b,color='blue',thickness=2,figsize=[3,2])
    fprime=diff(fcn,x)
    tangent_eq=fcn(x0)+fprime(x=x0)*(x-x0)# Encode the rhs of the equation of the tangent line
    tangent_plot=plot(tangent_eq,a,b,color='green',thickness=2,figsize=[3,2])
    G=fcn_plot+tangent_plot+point([x0,fcn(x=x0)],pointsize=40,color='red')
    rel_error=100*(tangent_eq(x=x0+c)-fcn(x=x0+c))/fcn(x=x0+c)
    print "Error: %s %%\n" % rel_error # Tricky format; just use it as a "black box"
    return G
fcn_and_tangent(cos(x),0.75,0,2,0.1)# Use your own example. Experiment with c, the change in x0
︡d96172a7-615a-4c3f-91ba-0f8d2459533c︡{"stdout":"Error: 0.536657187170416 %\n\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/318/tmp_jbokrO.svg","show":true,"text":null,"uuid":"4956900c-34e4-4c74-9477-614d988779ce"},"once":false}︡{"done":true}
︠53a02ff7-72ae-4aef-b5aa-a99749eaa5ca︠
#####################
#Exercise 4. Make a CAS function plot_piecewise_fcn(L) that takes a list of data points of a continuous piecewise linear function and returns a figure with the plots of the function and its derivative. Assume that the points on the list L are sorted in the ascending order of their x-coordinates. Test your function on the set of points of your choice.
︡a68d6643-d99d-457b-ac64-7f60e7305158︡
︠6fec3dfa-ac97-4d87-95ad-0a3a4826b112s︠

def my_piecewise_fcn(L):
    n=len(L)
    Gf=Graphics();Gfp=Graphics()# Graphics object provides another way of plotting multiple function in one figure
    for j in range(n-1):
        slope=(L[j+1][1]-L[j][1])/(L[j+1][0]-L[j][0])
        fprime=plot(slope,L[j][0],L[j+1][0],thickness=2,color='red')
        Gfp+=fprime
        eq=L[j][1]+slope*(x-L[j][0])
        fcn=plot(eq,L[j][0],L[j+1][0],thickness=2,color='blue')
        Gf+=fcn
    (Gf+Gfp).show(figsize=[4,3])

L=[[4.,1],[2.,3],[3.,-1.],[5.,0]]
my_piecewise_fcn(L)# Use your own example
︡5904c288-0cab-4510-90b3-0069d7e4eab9︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/318/tmp_glFkmd.svg","show":true,"text":null,"uuid":"e6d000b8-ebb1-441b-902a-41692d46ee2e"},"once":false}︡{"done":true}
︠a5d11d81-afae-4336-b13f-f32209203bab︠
#Remark: plotting piecewise function as a whole
f=piecewise([([(-1,0),1]),((0,1),2),((1,2),3)])
plot(f(x),(x,-1,2),detect_poles='False',thickness=3,figsize=[3,2])
︡f997f867-1b94-4264-b823-8c59ba66297e︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/754/tmp_cMkMxZ.svg","show":true,"text":null,"uuid":"a6386fec-5388-4e45-b8e6-e22488c37510"},"once":false}︡{"done":true}
︠8a78491b-2ec9-483f-9b47-9b81aeab41a3︠
#########################
#Exercise 2. Make a CAS function f_and_fprime(fcn, a, b) that takes a function differentiable on an interval [a, b] and returns a figure with plots of the function and its derivative on the interval. Use CAS command for finding the derivative function.
# No template. You are on your own.
def f_and_fprime(fcn, a, b)
    G=Graphics()
    

︡53ddd404-f399-44af-9acb-9ec2c9d035d8︡
︠cb60c0ca-f798-4e62-98f0-e69bcc9ca77c︠
###############################
#Exercise 5 (demo). Make a CAS function my_bisection(f, a, b, n) that takes function f,end points of an interval with a single root of the function, and a real number eps and returns the approximation of the root. The steps of the bisection method are repeated while the value of f at the midpoint of the current interval exceeds eps.Test your code on an example of your choice.
︡4ae93168-22c6-47a3-bcac-39a6977b24e5︡
︠722622a4-05cc-4608-a8ac-ee8bdf61b15bs︠

︡a60e8ced-d31d-4f13-9c02-f289b15247c2︡{"done":true}
︠ee37553e-92b1-442b-b277-c0ec4d23831as︠
#This code is a simplified fragment from function written by William Stein, the founder of SageMath
def bisect(f,a,b,eps):
    two = float(2)
    while True:
        c = (a+b)/two
        fa = f(a); fb = f(b); fc = f(c)
        if abs(fc) < eps: return c
        if fa*fc < 0:
            a, b = a, c
        elif fc*fb < 0:
            a, b = c, b
        else:
            raise ValueError, "f must have a sign change in the interval (%s,%s)"%(a,b)
f(x)=cos(x)-x
bisect(f,0,1,0.001)
︡342757c7-6fe0-4b0d-a243-7057978c7ec4︡{"stdout":"0.7392578125"}︡{"stdout":"\n"}︡{"done":true}
︠fae82b5f-b117-45ee-8e36-f7c320912ad5s︠
f(_)
#Remark about notation f(_):# The underline stand for the previous result of calculation
︡81c78a7a-07a7-40aa-a8dc-468094d993d8︡{"stdout":"-0.000289009146790087\n"}︡{"done":true}
︠287b44a8-2506-4d52-b899-316f1dbda9c5︠


︡2927eb82-be55-455e-ad40-533912ff00c3︡
︠7f64f82a-248a-4b43-ac29-ebaade1143b6︠
######################
#Exercise. Use your own example for testing the function bisect
︡1fc7a53d-a6f3-4a54-9c7e-4845756f2d39︡
︠d50a65bf-e572-4bd1-bcbd-8c8a277713ffs︠
######################
#Exercise 6. Make a CAS function my_MVT(f, a, b) that takes a function continuous on interval [a, b]  and differentiable in (a,b) and returns a figure similar to Fig. 6.4 in Lecture 6. You will need CAS root-finding command.
def my_MVT(f,a,b):
    G=Graphics()
    f_plot=plot(f,a,b,thickness=2,color='blue')
    G+=f_plot
    secant_slope=(f(x=b)-f(x=a))/(b-a)# enter the expression for the secant slope
    secant_plot=plot(f(x=a)+secant_slope*(x-a),a,b,thickness=2,color='red')# enter the expression for the secant equation
    G+=secant_plot
    #Find the x-coordinate of the point of tangency for tangent parallel to the secant
    t=find_root(diff(f(x),x)==secant_slope,a,b)
    tangent_plot=plot(f(x=t)+secant_slope*(x-t),a,b,thickness=2,color='red')
    G+=tangent_plot
    G.show(figsize=[4,3])
my_MVT(sin(x),-1,3)
︡7698bdad-92a1-4862-b62f-33f2c89df288︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/318/tmp_85DlqA.svg","show":true,"text":null,"uuid":"866681b1-f69d-444d-a775-a82c63361e45"},"once":false}︡{"done":true}
︠b087b85d-fe4e-4f60-8c6e-6d1421fd9fa3︠









